// tx builder imports
import IERC20ServiceInterface from './tx-builder/interfaces/ERC20';
import FaucetInterface from './tx-builder/interfaces/Faucet';
import LTAMigratorInterface from './tx-builder/interfaces/LTAMigrator';
import StakingInterface from './tx-builder/interfaces/Staking';
import SynthetixInterface from './tx-builder/interfaces/Synthetix';
import AaveGovernanceV2Interface from './tx-builder/interfaces/v2/AaveGovernanceV2';
import GovernanceDelegationTokenInterface from './tx-builder/interfaces/v2/GovernanceDelegationToken';

// math imports
import * as v1 from './v1';
import * as v2 from './v2';

// export helpers
export * from './helpers/bignumber';
export * from './helpers/pool-math';
export * from './helpers/ray-math';

// export current version (v2) as top-level
export * from './v2';

// export v1 and v2 as dedicated entry points
export { v1, v2 };

// reexport bignumber
export { BigNumber } from 'bignumber.js';

export { default as TxBuilderV2 } from './tx-builder/v2';
export { default as LendingPoolInterfaceV2 } from './tx-builder/interfaces/v2/LendingPool';

export * from './tx-builder/types';
export * from './tx-builder/types/WethGatewayMethodTypes';
export * from './tx-builder/types/LendingPoolMethodTypes';
export * from './tx-builder/types/FaucetMethodTypes';
export * from './tx-builder/types/GovernanceV2MethodTypes';
export * from './tx-builder/types/GovernanceV2ReturnTypes';
export * from './tx-builder/types/GovDelegationMethodTypes';

export * from './tx-builder/config';

export {
  IERC20ServiceInterface,
  LTAMigratorInterface,
  SynthetixInterface,
  StakingInterface,
  FaucetInterface,
  AaveGovernanceV2Interface,
  GovernanceDelegationTokenInterface,
};
